- Development Integration
- /
- SDK
- /
- Java
- /
Management module
- /
Manage users
- /
- Batch modify user information
¶ Modify user information in batches
Update time: 2025-07-23 07:34:21
This document is automatically generated based on https://github.com/authing/authing-docs-factory and https://api-explorer.genauth.ai V3 API, and is consistent with API parameters and return results. If the document description is incorrect, please refer to V3 API.
Modify user information in batches. Email, mobile phone number, user name, externalId are unique in the user pool. This interface will modify user information as an administrator, so there is no need to perform security checks such as mobile phone number verification code verification.
¶ Method Name
ManagementClient.updateUserBatch
¶ Request Parameters
| Name | Type | Is it required | Default Value | Description | Example Value |
|---|---|---|---|---|---|
| list | UpdateUserInfoDto[] | Yes | - | User list | [{"userId":"63f867961cxxxx41e7ccb582","status":"Activated","email":"test@example.com","username":"bob","name":"Zhang San","nickname":"Zhang San","password":"passw0rd","photo":"https://files.authing.co/authing-console/default-user-avatar.png","gender":"M","birthdate":"2022-06-03","country":"CN","province":"BJ","city":"BJ","address":"Beijing Chaoyang","streetAddress":"xx Street, Chaoyang District, Beijing","postalCode":"438100","company":"steamory","browser":"Mozilla/5.0 (Linux; Android 10; V2001A; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/87.0.4280.141 Mobile Safari/537.36 VivoBrowser/10.2.10.0","device":"iOS","givenName":"San","familyName":"Zhang","middleName":"James","profile":"alice","preferredUsername":"alice","website":"https://my-website.com","zoneinfo":"GMT-08:00","locale":"af","formatted":"132, My Street, Kingston, New York 12401.","region":"Xinjiang Uyghur Autonomous Region"}] |
| options | UpdateUserBatchOptionsDto | No | - | Optional parameters | {"autoGeneratePassword":true,"resetPasswordOnFirstLogin":true,"passwordEncryptType":"none"} |
¶ Request Response
Type: UserListRespDto
| Name | Type | Description |
|---|---|---|
| statusCode | number | Business status code, which can be used to determine whether the operation is successful. 200 means success. |
| message | string | Description |
| apiCode | number | Segmented error code, which can be used to get the specific error type (successful requests are not returned). For a detailed list of error codes, see: API Code List (opens new window) |
| requestId | string | Request ID. Returned when the request fails. |
| data | array | User list |
Example Results:
{
"statusCode": 200,
"message": "Operation successful",
"requestId": "934108e5-9fbf-4d24-8da1-c330328abd6c",
"data": {
"userId": "6229ffaxxxxxxxxcade3e3d9",
"createdAt": "2022-07-03T03:20:30.000Z",
"updatedAt": "2022-07-03T03:20:30.000Z",
"status": "Activated",
"workStatus": "Active",
"externalId": "10010",
"email": "test@example.com",
"phone": "188xxxx8888",
"phoneCountryCode": "+86",
"username": "bob",
"name": "Zhang San",
"nickname": "Zhang San",
"photo": "https://files.authing.co/authing-console/default-user-avatar.png",
"loginsCount": 3,
"lastLogin": "2022-07-03T03:20:30.000Z",
"lastIp": "127.0.0.1",
"gender": "M",
"emailVerified": true,
"phoneVerified": true,
"passwordLastSetAt": "2022-07-03T03:20:30.000Z",
"birthdate": "2022-06-03",
"country": "CN",
"province": "BJ",
"city": "BJ",
"address": "Beijing Chaoyang",
"streetAddress": "xx Street, Chaoyang District, Beijing",
"postalCode": "438100",
"company": "steamory",
"browser": "Mozilla/5.0 (Linux; Android 10; V2001A; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/87.0.4280.141 Mobile Safari/537.36 VivoBrowser/10.2.10.0",
"device": "iOS",
"givenName": "San",
"familyName": "Zhang",
"middleName": "James",
"profile": "alice",
"preferredUsername": "alice",
"website": "https://my-website.com",
"zoneinfo": "GMT-08:00",
"locale": "af",
"formatted": "132, My Street, Kingston, New York 12401.",
"region": "Xinjiang Uyghur Autonomous Region",
"userSourceType": "register",
"passwordSecurityLevel": 1,
"departmentIds": "[\"624d930c3xxxx5c08dd4986e\",\"624d93102xxxx012f33cd2fe\"]",
"identities": {
"identityId": "62299d8b866d2dab79a89dc4",
"extIdpId": "6076bacxxxxxxxxd80d993b5",
"provider": "wechat",
"type": "openid",
"userIdInIdp": "oj7Nq05R-RRaqak0_YlMLnnIwsvg",
"accessToken": "57_fK0xgSL_NwVlS-gmUwlMQ2N6AONNIOAYxxxx",
"refreshToken": "57_IZFu91Ak1Wg6DRytZFFIOd3upNF5lH7vPxxxxx",
"originConnIds": "[\"605492ac41xxxxe0362f0707\"]"
},
"identityNumber": "420421xxxxxxxx1234",
"customData": {
"school": "Beijing University",
"age": 22
},
"statusChangedAt": "2022-07-03T03:20:30.000Z"
}
}
¶ Data Structure
¶ UpdateUserInfoDto
| Name | Type | Is it required | Description | Example Value |
|---|---|---|---|---|
| userId | string | Yes | User's unique identifier. It can be Yes user ID, user name, email, mobile number, externalId, or ID in external identity source. For details, see the description of userIdType field. The default is user id. | 6229ffaxxxxxxxxcade3e3d9 |
| phoneCountryCode | string | No | Mobile area code. It is optional for mobile numbers in mainland China. GenAuth SMS service does not support international mobile numbers. You need to configure the corresponding international SMS service in GenAuth console. For a complete list of mobile area codes, please refer to https://en.wikipedia.org/wiki/List_of_country_calling_codes. | +86 |
| name | string | No | User's real name, not unique | Zhang San |
| nickname | string | No | Nickname | Zhang San |
| photo | string | No | Avatar link | https://files.authing.co/authing-console/default-user-avatar.png |
| externalId | string | No | Third-party external ID | 10010 |
| status | string | No | Current account status | Suspended |
| emailVerified | boolean | No | Email Yes No Verification | true |
| phoneVerified | boolean | No | Phone Number Yes No Verification | true |
| birthdate | string | No | Date of Birth | 2022-06-03 |
| country | string | No | Country | CN |
| province | string | No | Province | BJ |
| city | string | No | City | BJ |
| address | string | No | Address | Beijing Chaoyang |
| streetAddress | string | No | Street Address | Beijing Chaoyang District xxx Street |
| postalCode | string | No | Postal Code | 438100 |
| gender | string | No | Gender | M |
| username | string | No | Username, unique in the user pool | bob |
| string | No | Email address, case insensitive | test@example.com | |
| phone | string | No | Mobile number without area code. If Yes, it is a foreign mobile number, please specify the area code in the phoneCountryCode parameter. | 188xxxx8888 |
| password | string | No | User password, in plain text by default. We use the HTTPS protocol to securely transmit passwords, which can ensure security to a certain extent. If you need a higher level of security, we also support RSA256 and SM2 to encrypt passwords. See the passwordEncryptType parameter for details. | passw0rd |
| company | string | No | Company | steamory |
| browser | string | No | Last login browser UA | Mozilla/5.0 (Linux; Android 10; V2001A; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/87.0.4280.141 Mobile Safari/537.36 VivoBrowser/10.2.10.0 |
| device | string | No | Last login device | iOS |
| givenName | string | No | First name | xxx |
| familyName | string | No | Last Name | Zhang |
| middleName | string | No | Middle Name | James |
| profile | string | No | Preferred Username | alice |
| preferredUsername | string | No | Preferred Username | alice |
| website | string | No | User personal website | https://my-website.com |
| zoneinfo | string | No | User time zone information | GMT-08:00 |
| locale | string | No | Locale | af |
| formatted | string | No | Standard full address | 132, My Street, Kingston, New York 12401. |
| region | string | No | User's region | Xinjiang Uyghur Autonomous Region |
| identityNumber | string | No | User ID number | 420421xxxxxxxx1234 |
| customData | object | No | Custom data. The key in the passed object must first be defined in the user pool for the relevant custom fields | {"school":"Beijing University","age":22} |
| metadata | object | No | Data object data. The key in the passed object must first be defined in the user data object for the relevant custom fields | {"school":"Beijing University","age":22} |
¶ UpdateUserBatchOptionsDto
| Name | Type | Is it required | Description | Example Value |
|---|---|---|---|---|
| resetPasswordOnNextLogin | boolean | No | Require password reset on next login | |
| passwordEncryptType | string | No | Password encryption type, supports RSA256 and SM2 algorithms. The default is none, no encryption.- none: Do not encrypt the password, use plain text for transmission.- rsa: Use RSA256 algorithm to encrypt the password, and need to use the RSA public key of GenAuth service for encryption. Please read the Introduction section to learn how to obtain the RSA256 public key of GenAuth service.- sm2: Use SM2 algorithm (opens new window) to encrypt the password, and need to use the SM2 public key of GenAuth service for encryption. Please read the Introduction section to learn how to obtain the SM2 public key of GenAuth service. | sm2 |
| autoGeneratePassword | boolean | No | Yes No Automatically generate password | |
| sendPasswordResetedNotification | No | Option to send email and phone number to reset password Nested Type: SendResetPasswordNotificationDto. | {"sendDefaultEmailNotification":false,"sendDefaultPhoneNotification":false,"inputSendEmailNotification":"test@example.com","inputSendPhoneNotification":"136xxxx1234","appId":"app1"} |
¶ SendResetPasswordNotificationDto
| Name | Type | Is it required | Description | Example Value |
|---|---|---|---|---|
| sendDefaultEmailNotification | boolean | No | After resetting password, Yes No Send user default email notification | |
| sendDefaultPhoneNotification | boolean | No | After resetting the password, Yes No sends the user's default SMS notification | |
| inputSendEmailNotification | string | No | When the user's password is changed, enter the email address to send | test@example.com |
| inputSendPhoneNotification | string | No | When the user's password is changed, enter the mobile phone number to send | 183xxxx1234 |
| appId | string | No | When sending the login address, the specified application id will send the login address of this application to the user's email or mobile phone number. The default is the login address of the user pool application panel. | appid1 |
¶ UserDto
| Name | Type | Is it required | Description | Example Value |
|---|---|---|---|---|
| userId | string | Yes | The unique identifier of the user, which can be user ID, user name, email, phone number, externalId, or ID in an external identity source. For details, see the description of the userIdType field. The default is user id. | 6229ffaxxxxxxxxcade3e3d9 |
| createdAt | string | yes | creation time | 2022-07-03T03:20:30.000Z |
| updatedAt | string | yes | update time | 2022-07-03T03:20:30.000Z |
| status | string | yes | current status of the account: - Activated: normal status - Suspended: deactivated - Deactivated: disabled - Resigned: resigned - Archived: archived | Suspended |
| workStatus | string | yes | current work status of the account | Closed |
| externalId | string | no | third-party external ID | 10010 |
| string | no | email address, case insensitive | test@example.com | |
| phone | string | No | Phone number without area code. If it is a foreign phone number, specify the area code in the phoneCountryCode parameter. | 188xxxx8888 |
| phoneCountryCode | string | No | Mobile phone area code. This field is optional for mainland China mobile phone numbers. The GenAuth SMS service does not yet support international mobile phone numbers. You need to configure the corresponding international SMS service in the GenAuth console. For a complete list of mobile phone area codes, please refer to https://en.wikipedia.org/wiki/List_of_country_calling_codes. | +86 |
| username | string | No | Username, unique in the user pool | bob |
| name | string | No | User's real name, not unique | Zhang San |
| nickname | string | No | Nickname | Zhang San |
| photo | string | No | Avatar link | https://files.authing.co/authing-console/default-user-avatar.png |
| loginsCount | number | No | Total number of historical logins | 3 |
| lastLogin | string | No | Last login time | 2022-07-03T03:20:30.000Z |
| lastIp | string | No | Last login IP | 127.0.0.1 |
| gender | string | Yes | Gender: - M: Male, male- F: Female, female- U: unknown, unknown | M |
| emailVerified | boolean | yes | Email verified | true |
| phoneVerified | boolean | yes | Phone number verified | true |
| passwordLastSetAt | string | no | User's last password change time | 2022-07-03T03:20:30.000Z |
| birthdate | string | No | Date of birth | 2022-06-03 |
| country | string | No | Country | CN |
| province | string | No | Province | BJ |
| city | string | No | City | BJ |
| address | string | No | Address | Beijing Chaoyang |
| streetAddress | string | No | Street address | Beijing Chaoyang District xxx Street |
| postalCode | string | No | Postal code | 438100 |
| company | string | No | Company | steamory |
| browser | string | No | Last browser used for login UA | Mozilla/5.0 (Linux; Android 10; V2001A; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/87.0.4280.141 Mobile Safari/537.36 VivoBrowser/10.2.10.0 |
| device | string | No | The device used when logging in last time | iOS |
| givenName | string | no | first name | xxx |
| familyName | string | no | last name | xx |
| middleName | string | no | middle name | James |
| profile | string | no | Preferred Username | alice |
| preferredUsername | string | no | Preferred Username | alice |
| website | string | no | User personal website | https://my-website.com |
| zoneinfo | string | no | User time zone information | GMT-08:00 |
| locale | string | no | Locale | af |
| formatted | string | no | Full standard address | 132, My Street, Kingston, New York 12401. |
| region | string | no | User location | Xinjiang Uyghur Autonomous Region |
| userSourceType | string | yes | Source type: - excel: via excel Import- register: User self-registration- adminCreated: Manual creation by the administrator (including creating users using the management API)- syncTask: Sync task in the sync center | excel |
| userSourceId | string | No | Application ID or sync task ID | |
| lastLoginApp | string | No | The app the user last logged into ID | |
| mainDepartmentId | string | No | User's primary department ID | |
| lastMfaTime | string | No | The time when the user last performed MFA authentication | |
| passwordSecurityLevel | number | No | User password security strength level | 1 |
| resetPasswordOnNextLogin | boolean | No | Require password reset on next login | |
| registerSource | array | No | Registration method | |
| departmentIds | array | No | User department ID list | ["624d930c3xxxx5c08dd4986e","624d93102xxxx012f33cd2fe"] |
| identities | array | No | External identity source nested Type: IdentityDto. | |
| identityNumber | string | No | User ID number | 420421xxxxxxxx1234 |
| customData | object | No | User's extended field data | {"school":"Beijing University","age":22} |
| postIdList | array | No | User-associated department ID | |
| statusChangedAt | string | No | User status last modified time | 2022-07-03T03:20:30.000Z |
| tenantId | string | No | User tenant ID |
¶ IdentityDto
| Name | Type | Is it required | Description | Example Value |
|---|---|---|---|---|
| identityId | string | Yes | Identity source ID | 62299d8b866d2dab79a89dc4 |
| extIdpId | string | Yes | Identity source connection ID | 6076bacxxxxxxxxd80d993b5 |
| provider | string | Yes | External identity source Type: - wechat: WeChat- qq: QQ- wechatwork: WeChat for Business- dingtalk: DingTalk- weibo: Weibo- github: GitHub- alipay: Alipay- baidu: Baidu- lark: Feishu- welink: Welink- yidun: NetEase Yidun- qingcloud: Qingyun- google: Google- gitlab: GitLab- gitee: Gitee- twitter: Twitter- facebook: Facebook- slack: Slack- linkedin: Linkedin- instagram: Instagram- oidc: OIDC-type enterprise identity source- oauth2: OAuth2-type enterprise identity source- saml: SAML-type enterprise identity source- ldap: LDAP-type enterprise identity source- ad: AD-type enterprise identity source- cas: CAS-type enterprise identity source- azure-ad: Azure AD-type enterprise identity source | oidc |
| type | string | Yes | Identity type, such as unionid, openid, primary | openid |
| userIdInIdp | string | Yes | ID in the external identity source | oj7Nq05R-RRaqak0_YlMLnnIwsvg |
| userInfoInIdp | object | Yes | User's identity information in idp | |
| accessToken | string | No | Access Token in the external identity source (this parameter is only returned when the user actively obtains it, and the management side interface will not return it). | 57_fK0xgSL_NwVlS-gmUwlMQ2N6AONNIOAYxxxx |
| refreshToken | string | No | Refresh Token in the external identity source (this parameter is only returned when the user actively obtains it, and the management side interface will not return it). | 57_IZFu91Ak1Wg6DRytZFFIOd3upNF5lH7vPxxxxx |
| originConnIds | array | Yes | List of identity origin connection IDs that the identity comes from | ["605492ac41xxxxe0362f0707"] |
